# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
import pydantic
from .fallback_google_transcriber_model import FallbackGoogleTranscriberModel
from .fallback_google_transcriber_language import FallbackGoogleTranscriberLanguage
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class FallbackGoogleTranscriber(UncheckedBaseModel):
    provider: typing.Literal["google"] = pydantic.Field(default="google")
    """
    This is the transcription provider that will be used.
    """

    model: typing.Optional[FallbackGoogleTranscriberModel] = pydantic.Field(default=None)
    """
    This is the model that will be used for the transcription.
    """

    language: typing.Optional[FallbackGoogleTranscriberLanguage] = pydantic.Field(default=None)
    """
    This is the language that will be set for the transcription.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
