# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing_extensions
import typing
from ..core.serialization import FieldMetadata
import pydantic
from .update_org_dto_channel import UpdateOrgDtoChannel
from .server import Server
from .compliance_plan import CompliancePlan
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class UpdateOrgDto(UncheckedBaseModel):
    hipaa_enabled: typing_extensions.Annotated[typing.Optional[bool], FieldMetadata(alias="hipaaEnabled")] = (
        pydantic.Field(default=None)
    )
    """
    When this is enabled, no logs, recordings, or transcriptions will be stored. At the end of the call, you will still receive an end-of-call-report message to store on your server. Defaults to false.
    When HIPAA is enabled, only OpenAI/Custom LLM or Azure Providers will be available for LLM and Voice respectively.
    This is due to the compliance requirements of HIPAA. Other providers may not meet these requirements.
    """

    subscription_id: typing_extensions.Annotated[typing.Optional[str], FieldMetadata(alias="subscriptionId")] = (
        pydantic.Field(default=None)
    )
    """
    This is the ID of the subscription the org belongs to.
    """

    name: typing.Optional[str] = pydantic.Field(default=None)
    """
    This is the name of the org. This is just for your own reference.
    """

    channel: typing.Optional[UpdateOrgDtoChannel] = pydantic.Field(default=None)
    """
    This is the channel of the org. There is the cluster the API traffic for the org will be directed.
    """

    billing_limit: typing_extensions.Annotated[typing.Optional[float], FieldMetadata(alias="billingLimit")] = (
        pydantic.Field(default=None)
    )
    """
    This is the monthly billing limit for the org. To go beyond $1000/mo, please contact us at support@vapi.ai.
    """

    server: typing.Optional[Server] = pydantic.Field(default=None)
    """
    This is where Vapi will send webhooks. You can find all webhooks available along with their shape in ServerMessage schema.
    
    The order of precedence is:
    
    1. assistant.server
    2. phoneNumber.server
    3. org.server
    """

    concurrency_limit: typing_extensions.Annotated[typing.Optional[float], FieldMetadata(alias="concurrencyLimit")] = (
        pydantic.Field(default=None)
    )
    """
    This is the concurrency limit for the org. This is the maximum number of calls that can be active at any given time. To go beyond 10, please contact us at support@vapi.ai.
    """

    compliance_plan: typing_extensions.Annotated[
        typing.Optional[CompliancePlan], FieldMetadata(alias="compliancePlan")
    ] = pydantic.Field(default=None)
    """
    Stores the information about the compliance plan enforced at the organization level. Currently pciEnabled is supported through this field.
    When this is enabled, any logs, recordings, or transcriptions will be shipped to the customer endpoints if provided else lost.
    At the end of the call, you will receive an end-of-call-report message to store on your server, if webhook is provided.
    Defaults to false.
    When PCI is enabled, only PCI-compliant Providers will be available for LLM, Voice and transcribers.
    This is due to the compliance requirements of PCI. Other providers may not meet these requirements.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
