# This file was auto-generated by Fern from our API Definition.

from ..core.unchecked_base_model import UncheckedBaseModel
import typing
from .workflow_nodes_item import WorkflowNodesItem
from .workflow_model import WorkflowModel
import pydantic
import typing_extensions
from ..core.serialization import FieldMetadata
import datetime as dt
from .edge import Edge
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class Workflow(UncheckedBaseModel):
    nodes: typing.List[WorkflowNodesItem]
    model: typing.Optional[WorkflowModel] = pydantic.Field(default=None)
    """
    These are the options for the workflow's LLM.
    """

    id: str
    org_id: typing_extensions.Annotated[str, FieldMetadata(alias="orgId")]
    created_at: typing_extensions.Annotated[dt.datetime, FieldMetadata(alias="createdAt")]
    updated_at: typing_extensions.Annotated[dt.datetime, FieldMetadata(alias="updatedAt")]
    name: str
    edges: typing.List[Edge]

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
